;************************************
;* Title: mode E+ border demo       *
;* Author: pavros                   *
;* Date: 2009-07-08                 *
;************************************

	lda $14
	cmp $14
	beq *-2         ;wait for new screen frame

	lda #$00
	sta nmien       ;disable all NMI
	sta nmires
	sei ;turn off all IRQ
	lda #$00
	;sta dmactls
	sta dmactl      ;disable screen dma

	lda #BANKSTD
	sta portb

	lda #lo(nmiCommonHnd)
	sta nmivec
	lda #hi(nmiCommonHnd)
	sta nmivec+1
	lda #lo(irqCommonHnd)
	sta irqvec
	lda #hi(irqCommonHnd)
	sta irqvec+1

	lda #lo(dliHnd)   ;setup DLI vector
	sta dliv
	lda #hi(dliHnd)
	sta dliv+1

	lda #lo(dList2)  ;setup Display List vector
	sta dlptr
	;sta dlptrs
	lda #hi(dList2)
	sta dlptr+1
	;sta dlptrs+1


	ldx #4
colLoop
	lda colors2,x
	sta colpf0,x
	dex
	bpl colLoop

	lda #$00
	sta vblCnt
	sta vblCnt+1

	lda #$C0
	sta nmien       ;enable VBLKI and DLI
	lda #$22
	;sta dmactls
	sta dmactl      ;enable screen dma

	;cli

loop
	lda #$18
loop1
	clc
	sbc #1
	bne loop1
	lda vblCnt+1
	and #$01
	beq loop2
	lda #$FF
loop2
	sta colbakMask
	sta dliColbakMask
	lda random
colbakMask = * + 1
	and #$FF
	sta colbak
	jmp loop


colors
	db $24,$F8,$EC,$46,$00

colors2
	db $00,$24,$F8,$EC,$00


vBlkInt
	pha
	inc vblCnt
	lda vblCnt
	bne vBlkInt1
	lda vblCnt+1
	adc #1
	sta vblCnt+1
vBlkInt1
	pla
	rti


dliHnd
	pha
	lda #$00
	sta nmien
dliHnd1
	lda #$C0
	sta wsync
	sta $D01B
	;nop
	;nop
	;nop
	;nop
	;nop
	lda random
dliColbakMask = * + 1
	and #$FF
	sta colbak
	nop
	nop
	nop
	lda #$00
	sta $D01B
	inc dliCnt
dliCnt = * + 1
	lda #$00
	cmp #$C8
	bcc dliHnd1
	lda #$00
	sta dliCnt
	lda #$C0
	sta nmien
	pla
	rti


 org dlAdr


;dList

;	db	$70,$70,$30
;	db	$4E,lo(picAdr),hi(picAdr)
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E
;	db	$4E,lo(picAdr+$FF0),hi(picAdr+$FF0)
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E
;	db	$41,lo(dList),hi(dList)


dList2

	db	$70,$70,$B0
	db	$4F,lo(picAdr),hi(picAdr)
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F,$0F,$0F,$0F,$0F
	db	$4F,lo(picAdr+$FF0),hi(picAdr+$FF0)
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	db	$0F
	db	$41,lo(dList2),hi(dList2)
